

package jcm.gui.plot;

import jcm.core.*;
import jcm.core.par.param;
import jcm.core.cur.curve;
import jcm.core.cur.curveset;
import jcm.core.reg.region;

public class qtsetcolormap  implements colormap {
    
    curveset qq; param year; double min, max; boolean hasresetscale=true;
    float scalar =1f;
    qtsetcolormap(curveset qq) {
	this.qq=qq;
	year=new param("mapyear", 2000, qq.sy, qq.ey, "");
    }
    
    public float getValue(region r) { return scalar*qq.get(r, (int)year.val); }
    public String getMapInfo(region r) {return ""+((int)scalar*qq.get(r, (int)year.val)*100)/100f; }
    public double getmin( ){ return min; }
    public double getrange(){ if ((max-min)<10) { scalar=1000f; resetscale(); } return (max-min); }
    public void resetscale() {
	min=Double.MAX_VALUE; max=Double.MIN_VALUE;
	for (curve q : qq.mapwithouttotal().values()) { float f=scalar*q.get((int)year.val);  min=Math.min(min, f); max=Math.max(max, f); }
	hasresetscale=true;
    }
    public boolean  hasresetscale() { if (hasresetscale) { hasresetscale=false; return true;  } return false; }
    
    
}
